import { hasProperty, isRecord } from './record.js';
const variablePlaceholderSymbol = Symbol('GraphQL Variable Placeholder');
export function isVariablePlaceholder(value) {
    return isRecord(value) && hasProperty(value, 'tag') && value.tag === variablePlaceholderSymbol;
}
const graphqlVariableIdentifierPattern = /^\$[A-Z_a-z]\w*$/;
export function isValidVariableIdentifier(value) {
    return graphqlVariableIdentifierPattern.test(value);
}
export function variablePlaceholder(variableName) {
    if (!isValidVariableIdentifier(variableName)) {
        throw new Error(`Variable "${variableName}" is not a valid variable name`);
    }
    return {
        variableName,
        tag: variablePlaceholderSymbol
    };
}
//# sourceMappingURL=variable-placeholder.js.map